'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createObjectMethodTransform;

var _package = require('../../package.json');

var _createImport = require('./createImport');

var _createImport2 = _interopRequireDefault(_createImport);

var _isPolyfillPath = require('./isPolyfillPath');

var _isPolyfillPath2 = _interopRequireDefault(_isPolyfillPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createObjectMethodTransform(polyfill) {
  const [object, property] = polyfill.split('.');
  return {
    CallExpression(path, { file }, { types: t }) {
      const { filename } = file.opts;
      if ((0, _isPolyfillPath2.default)(filename)) {
        return;
      }
      if (!t.isMemberExpression(path.node.callee) || !t.isIdentifier(path.node.callee.object) || !t.isIdentifier(path.node.callee.property) || path.node.callee.object.name !== object || path.node.callee.property.name !== property) {
        return;
      }

      const identifier = (0, _createImport2.default)(file, polyfill.split('.').join('_'), `${_package.name}/polyfills/${polyfill.split('.').join('/')}`);

      path.replaceWith(t.callExpression(identifier, path.node.arguments));
    }
  };
}